// -*- C++ -*- //

#ifndef NBTAB_H
#define NBTAB_H

class NoteBookTab;

#include "mapstorage.h"
#include "map_win.h"
#include "graph_displayer_canvas.h"
#include <libgnomecanvasmm.h>
#include <libgnomecanvasmm/polygon.h>

class NoteBookTab : public Gtk::VBox
{
public:
  NoteBookTab();
  
  MapStorage mapstorage;
    
  sigc::signal<void, std::string> signal_title;

  sigc::signal<void, std::string> signal_title_ch();

  sigc::signal<void, NoteBookTab *, bool> signal_newmap;

  sigc::signal<void, NoteBookTab *, bool> signal_newmap_needed();

  void readFile(const std::string &);
    
  ///The graph will be drawn on this \ref GraphDisplayerCanvas
  GraphDisplayerCanvas * gd_canvas;

  bool mapwinexists;

  MapWin * mapwin;
    
public:
  ///Callback for 'FileNew' action.
  virtual void newFile();
  ///Callback for 'FileOpen' action.
  virtual void openFile();
  ///Callback for 'FileSave' action.
  virtual void saveFile();
  ///Callback for 'FileSaveAs' action.
  virtual void saveFileAs();
  ///Callback for 'Close' action.
  virtual void close();

  void propertyChange(bool, int, std::string);
  void popupNewMapWin(bool, int);

  std::string getActiveEdgeMap(int);
  std::string getActiveNodeMap(int);

  void registerNewEdgeMap(std::string);
  void registerNewNodeMap(std::string);

  void createMapWin(std::string);
  void closeMapWin();
};

#endif //NBTAB_H
